<%--
 @purpose      This file is used by 'Manage Data Sources' module.
 @caveats      This file makes the header portion of all the Add/Edit screens for resource servers. 
 @author       RSI offshore team
--%>
<%@page import="java.lang.*,java.util.*,com.hyperformix.athens.beans.*,com.hyperformix.athens.utilities.*,com.hyperformix.athens.common.*"%>
<%@ page import="java.util.Enumeration" %>
<%@ taglib uri="/tags/athens" prefix="athens" %>
<%@ taglib uri="/tags/struts-bean" prefix="bean" %>
<%@ taglib uri="/tags/struts-html" prefix="html" %>

 <html:base/>
<script language="JavaScript" type="text/javascript">

var NO_MORE_TEXT	= '<bean:message key='datasource.no_more_text'/>';

function chParameters(){
	document.myForm.action = "NewDataSource.do";
	document.myForm.submit();
}


function listPage(myForm){				
	document.myForm.action = 'ListDataSource.do';
	document.myForm.submit();
}

function checkSize(size, txt) {
	if(txt.value.length > size)
	{
	txt.value = txt.value.substring(0,size);
	alert(NO_MORE_TEXT);
	}
}
function popUpError()
{
var msg="";
<%
	Vector error1 = null;
	if(request.getAttribute("error")!=null)
	error1 = (Vector)request.getAttribute("error");
	if(error1!= null){
		for(int i = 0;i<error1.size();i++){
	%>
		msg = msg+'<%=error1.get(i)%>'+"\n";
	<%
		}
	}
	%>
	if(msg!="")
		alert(msg);
}

</script>

<%!
// The following is the mapping of parameter Field Names in SOURCE_PARAMS_CONFIG
private final String db_url = "JDBC_URL";
private final String db_HostName = "HostName";
private final String db_Name = "DbName";
private final String db_Type = "DbType";
private final String db_Platform = "DbPlatform";
private final String db_Port = "Port";
private final String db_User = "DbUser";
private final String db_Password = "DbPass";
private final String db_RServer = "RSSRV";
private final String hpOvi_HostName = "HostName";
private final String hpOvi_Port = "Port";
private final String hpOvi_OpenView = "Openview";
private final String hpOvi_RServer = "RSSRV";
private final String hpOvpm_Port = "Port";
private final String hpOvpm_Protocol = "Protocol";
private final String hpOvpm_Version = "version";
private final String hpOvpm_Datasource = "datasource";
private final String hpOvpm_Granularity = "granularity"; 
private final String hpOvpm_Customer = "customer";
private final String hpOvpm_Password = "password";
private final String hpOvpm_ProxyHost = "proxyhost";
private final String hpOvpm_ProxyPort = "proxyport";
private final String hpOvpm_ProxyUsername = "proxyusername";
private final String hpOvpm_ProxyPassword = "proxypassword";

private final String wilyApm_HostName = "hostname";
private final String wilyApm_Port = "port";
private final String wilyApm_Version = "version"; 
private final String wilyApm_Protocol = "protocol";
private final String wilyApm_Granularity = "granularity"; 
private final String wilyApm_User = "user";
private final String wilyApm_Password = "password";
private final String wilyApm_RServer = "RSSRV";


//Added for VMWare API Adapter
//by mayank singhal
private final String vmAPI_HostName = "hostname";
private final String vmAPI_Port = "port";
private final String vmAPI_Granularity = "granularity"; 
private final String vmAPI_User = "user";
private final String vmAPI_Password = "password";
private final String vmAPI_RServer = "RSSRV";
private final String vmAPI_chunk = "chunk_size";





private final String rib_HostName = "hostname";
private final String rib_Port = "rib_port";
private final String rest_Port = "rest_port"; 
private final String rib_Version = "version";
private final String rib_Protocol = "protocol";
private final String rib_Granularity = "granularity"; 
private final String rib_User = "username";
private final String rib_Password = "password";
private final String rib_RServer = "RSSRV";

private final String sap_Client = "jco.client.client";
private final String sap_Password = "jco.client.passwd";
private final String sap_R3Name = "jco.client.r3name";
private final String sap_SystemNumber = "jco.client.sysnr";
private final String sap_User = "jco.client.user";
private final String sar_FPath = "FPATH";
private final String sar_FName = "FNAME";
private final String perfmon_FPath = "FPATH";
private final String perfmon_FName = "FNAME";
private final String bmc_FPath = "FPATH";
private final String bmc_FName = "FNAME";
private final String db2_FPath = "FPATH";
private final String db2_FName = "FNAME";

private final String generic_FPath = "FPATH";
private final String generic_FName = "FNAME";
private final String prognosis_FPath = "FPATH";
private final String prognosis_FName = "FNAME";
/* changes for workload 28/4 leena */
private final String workload_FName = "FNAME";
private final String workload_FPath = "FPATH";
/* end of changes for workload 28/4 leena */

/* time zone 9 may 05 */
private final String sar_TZone = "TIME_ZONE";
private final String perfmon_TZone = "TIME_ZONE";
private final String bmc_TZone = "TIME_ZONE";
private final String db2_TZone = "TIME_ZONE";
private final String workload_TZone = "TIME_ZONE";
private final String generic_TZone = "TIME_ZONE";
private final String prognosis_TZone = "TIME_ZONE";
private final String wilyApm_TZone = "TIME_ZONE";
private final String rib_TZone = "TIME_ZONE";
/* end of time zone 9 may 05 */

/* Filtering of metrics */
private final String db_App     = "METRICGROUP_APPLICATION";
private final String db_Cluster = "METRICGROUP_CLUSTER";
private final String db_Dsk     = "METRICGROUP_DISK";
private final String db_Datastore = "METRICGROUP_ENTITY";
private final String db_Net     = "METRICGROUP_NETWORK";
private final String db_Prc     = "METRICGROUP_PROCESS";
private final String db_RscPool = "METRICGROUP_RESOURCE_POOL";
private final String db_Sys     = "METRICGROUP_SYSTEM";
private final String db_Wkl     = "METRICGROUP_WORKLOAD_LOG";
private final String db_Cpu     = "METRICGROUP_CPU";
private final String db_Config  = "METRICGROUP_CONFIGURATION";
private final String hp_ovi_Prc = "METRICGROUP_PROCESS";
private final String hp_ovi_App = "METRICGROUP_APPLICATION";
private final String hp_ovi_Net = "METRICGROUP_NETWORK";
private final String hp_ovi_Dsk  = "METRICGROUP_DISK";
private final String wilyApm_Sys = "METRICGROUP_SYSTEM";
private final String wilyApm_Prc = "METRICGROUP_PROCESS";
private final String wilyApm_Wkl = "METRICGROUP_WORKLOAD";
private final String rib_Sys = "METRICGROUP_SYSTEM";
private final String rib_Prc = "METRICGROUP_PROCESS";
private final String rib_Wkl = "METRICGROUP_WORKLOAD";
private final String db_Wkl_Trans = "METRICGROUP_WORK_TRANS";


private final int DATASOURCE_DESC_SIZE = 255;	/* DATASOURCE_DESC field in DATASOURCES_CONFIG */
private final int DEFAULT_SIZE = 37;
private final int MAX_SIZE     = 1000;			/* VALUE field in DATASOURCES_DETAILS_CONFIG */

/* default drop down strings */
private final String hp_ovpm_default_version     = "OVPM 8.2";
private final String hp_ovpm_default_datasource  = "auto";
private final String hp_ovpm_default_protocol    = "http";
private final String hp_ovpm_default_granularity = "auto";

private final String wilyApm_default_version     = "CA APM 9.x";
private final String wilyApm_default_protocol    = "http";
private final String wilyApm_default_granularity = "5 min";

private final String rib_default_version     = "RIB";
private final String rib_default_protocol    = "http";
private final String rib_default_granularity = "5 min";
%>

<%
if( request.getSession() == null)
	response.sendRedirect("login.jsp");
	
ConfigBean[] configBean = (ConfigBean[])request.getSession().getAttribute("configBean");

String flag = (String)request.getAttribute("editflag");
if(flag == null)flag = "";
String dataSourceDescription = "";
String dataSourceName = "";
Object name = request.getParameter("sourceName");
if(name != null) dataSourceName = name.toString();
String dataSourceType = "";
DataSourceDetails data = new DataSourceDetails();
int type = 0;
ParametersBean[] params = new ParametersBean[1];
String activeSchedules = (String)request.getAttribute("activeSchedules");

if (flag.equalsIgnoreCase("true") || flag.equalsIgnoreCase("error")){
	data = (DataSourceDetails)request.getAttribute("data");
	type = data.getTypeID();
	dataSourceDescription = data.getDataSourceDescription();
	dataSourceName = data.getDataSourceName();
	dataSourceType = data.getTypeDesc();
	params = data.getParams();
	
}else{
	type = Integer.parseInt(request.getAttribute("dataSourceType").toString());	
	dataSourceType = new Integer(type).toString();	
	for(int i = 0;i<configBean.length;i++){
		if(type == configBean[i].getTypeId()){	
			params = configBean[i].getParams();
		}
	}
}
%>

<script language="JavaScript" type="text/javascript">
    function onSave()
    {
    	submitPage('<%if(flag.equalsIgnoreCase("true")) out.print("UpdateDataSource.do");  else out.print("SaveDataSource.do"); %>',document.myForm)
    }
</script>

<br>
<% String dataSourceName1 = new String("");
dataSourceName1 = (String)request.getSession().getAttribute("dataSourceName");
ParametersBean[] paramBean= (ParametersBean[])request.getSession().getAttribute("paramBean");%>
<table  border='0' cellspacing='0' cellpadding='0' width=95% >
	<tr>
		<td class='pageTitle' width="88%" align="right"><img  src="Images/darkBg-icons/data-sources.jpg"></td>
		<td class='pageTitle'width="10%"  style="white-space: nowrap;">&nbsp;&nbsp;Manage Data Sources</td>
		<td aling="left"><img src = "Images/right-curve.jpg" border="0"></td>
	</tr>
</table>

<br>

<table width='95%' cellspacing='0' cellpadding='0' border=0>
	<tr>
		<td>
			<table  border='0' cellspacing='0' cellpadding='0' width=100% >
				<tr>
					<td class='heading' width="98%" colspan=3 style="white-space: nowrap;">&nbsp;&nbsp;<%if(flag.equalsIgnoreCase("true")) out.print("Edit"); else out.print("Add");%> Data Source</td>
					<td aling="left"><img src = "Images/right-curve-light.jpg" border="0"></td>
				</tr>	
			</table>	
<table width='100%' cellspacing='0' cellpadding='0'  class="details" border='0' style = "border-bottom:none">
<tr>
<td valign="top" width="50%">
<table width="100%" cellSpacing=0 cellPadding=5 border=0>
	<tr><td height='20px'></td></tr>
	<tr>
		<td class='label'>
			<label for="sourceName" id="sourceNameLabel" class="appLabels">Data source name:</label>
		</td>
		<td><input type="text" id="sourceName" name="sourceName" 
		   value = "<%if(flag.equalsIgnoreCase("true")||flag.equalsIgnoreCase("error")) 
		               out.print(dataSourceName);
		              else
		               out.print(dataSourceName1); %>"
		  size='29' maxlength='80'>
		<input type="hidden" id = "dataSourceId" name = "dataSourceId" value="<%if(flag.equalsIgnoreCase("true")||flag.equalsIgnoreCase("error")) out.print(data.getDataSourceId());%>"> 
		</td>								
		<td></td>
	</tr>
	<tr>
		<td class="appLabels">Data source type:</td>
		
		<% if(flag.equalsIgnoreCase("true")||flag.equalsIgnoreCase("error"))
		{
		%>	
		<td><Input  value='<%=dataSourceType%>' size='29' disabled><input type="hidden" id = "dataSourceType" name = "dataSourceType" value="<%=type%>">
		</td> </tr>
		<%
		}
		else
		{
		%>

		<td><select id="dataSourceType" onchange="chParameters()" name="dataSourceType">
		<!-- This Select Tag controls the visibility property of the Div elements embebed below,the values of the option element are the same as the DIV elements's ID.To ensure the working of a new DIV element put it's ID in a new Options element here as well as the Names array above-->
		<%		
		for(ConfigBean cb : configBean)
        {
            if (!cb.isTypeEnabled())
                continue;

            out.print("<option value=\"");
            out.print(cb.getTypeId());												
            out.print("\"");

            if(cb.getTypeId() == type)out.print("selected ");
              out.print(">");												
            out.print(cb.getTypeDescription());
            out.println("</option>");
		}
		%>
		</select>
		</td>
		<td></td>
		</tr>
<%

 if(paramBean.length>0){
%>		
<tr>
		<td class="appLabels">Host list: </td>
		<td>
		<select id="dataSourceParams" onchange="changeParameters()" name="dataSourceParams">
		<!-- This Select Tag controls the visibility property of the Div elements embebed below,the values of the option element are the same as the DIV elements's ID.To ensure the working of a new DIV element put it's ID in a new Options element here as well as the Names array above-->
		<%
		for(int i = 0;i<paramBean.length;i++){
		if(i==paramBean.length-1)
		out.print("<option selected value=\"");
		else
		out.print("<option value=\"");
		out.print(paramBean[i].getParamValue());												
		out.print("\"");
		
		//if(paramBean[i].getParamCode() == "")out.print("selected ");
		out.print(">");												
		out.print(paramBean[i].getParamCode());
		out.println("</option>");
		}	
			
		%>					
		</select>
	</td>
	</tr>
		<%	
		}}			
		%>					
	<tr>
        <td class="appLabels">Active data source:</td>
        <td><input type="checkbox" name='active' id='active' <%= data.isActive()? "checked": ""%>></td>
    </tr>
	<tr>
        <td class="appLabels">Calculate load statistics:</td>
        <td><input type="checkbox" name='calculateStatistics' <%= data.isCalculateStatistics()? "checked": ""%>></td>
    </tr>
</table>
		</td>
		<td>
             <table>
                 <tr><td class="appLabels" style="text-align:left">Description:</td></tr>
                 <tr><td ><TEXTAREA name="userComments" id="userComments" class="select" rows="6" cols="55" onKeyUp='checkSize(<%=DATASOURCE_DESC_SIZE%>, this)'><%=dataSourceDescription%></TEXTAREA></tr>
             </table>
		</td>
		<td>
            <%
            if(request.getParameter("first") != null)
            {
            %>
            <input name="updateSchedule" type="hidden" value="false">
            <input name="first" type="hidden" value="<%=request.getParameter("first")%>">
            <input name="last" type="hidden" value="<%=request.getParameter("last")%>">
            <%
            }
            %>
        </td>
    </tr>
</table>

<%!

private String extractValue(int id, String value, HttpServletRequest request)
{
	String r_txt = "";
	boolean flag = false;
	String select = "";
	DSParameterConstraint dataSourceParamConstraint[];
	dataSourceParamConstraint = (DSParameterConstraint[])request.getAttribute("dataSourceConstraint");
	if(dataSourceParamConstraint != null)
	{
		r_txt = "<select id='ID"+id+"' name='ID"+id+"'>";
		for(int i = 0; i < dataSourceParamConstraint.length; i++)
		{
			if(dataSourceParamConstraint[i].getIncludeFlag() == '1' && dataSourceParamConstraint[i].getParamID() == id)
			{
			flag = true;
			select = "";
			if(dataSourceParamConstraint[i].getParamValue() != null && value.equals(dataSourceParamConstraint[i].getParamValue()) )
			select = " selected";
			r_txt += "<option value='" + dataSourceParamConstraint[i].getParamValue()+"' " + select + ">"+dataSourceParamConstraint[i].getParamValue() +"</option>";
			}
		}
		r_txt += "</select>";
	}
	
	if(!flag)
	{
		r_txt = "<input type='text' id='ID"+id+"' name='ID"+id+"' size="+DEFAULT_SIZE+" class = 'label' value='"+value+"' maxlength='"+MAX_SIZE+"'>";
	}
	
	return r_txt;
}


private String extractValueSetSpecificValue(int id, String value, HttpServletRequest request,
		String defaultStr)
{
	String r_txt = "";
	boolean flag = false;
	String select = "";
	DSParameterConstraint dataSourceParamConstraint[];
	dataSourceParamConstraint = (DSParameterConstraint[])request.getAttribute("dataSourceConstraint");
	if(dataSourceParamConstraint != null)
	{
		r_txt = "<select id='ID"+id+"' name='ID"+id+"'>";
		for(int i = 0; i < dataSourceParamConstraint.length; i++)
		{
			if(dataSourceParamConstraint[i].getIncludeFlag() == '1' && dataSourceParamConstraint[i].getParamID() == id)
			{
			flag = true;
			select = "";
			if((dataSourceParamConstraint[i].getParamValue() == null || value.equals(""))
				&& dataSourceParamConstraint[i].getParamValue().equalsIgnoreCase(defaultStr) )
				select = " selected";
			else {
				if(value.equals(dataSourceParamConstraint[i].getParamValue()) )
					select = " selected";
			}
			r_txt += "<option value='" + dataSourceParamConstraint[i].getParamValue()+"' " + select + ">"+dataSourceParamConstraint[i].getParamValue() +"</option>";
			}
		}
		r_txt += "</select>";
	}
	
	if(!flag)
	{
		r_txt = "<input type='text' id='ID"+id+"' name='ID"+id+"' size="+DEFAULT_SIZE+" class = 'label' value='"+value+"' maxlength='"+MAX_SIZE+"'>";
	}
	
	return r_txt;
}
%>